import { useMessage } from "/@/hooks/web/useMessage";
import { defHttp } from "/@/utils/http/axios";

const { createConfirm } = useMessage();

enum Api {
  list = '/base.domain/stDomain/rootList',
  save='/base.domain/stDomain/add',
  edit='/base.domain/stDomain/edit',
  deleteStDomain = '/base.domain/stDomain/delete',
  importExcel = '/base.domain/stDomain/importExcel',
  exportXls = '/base.domain/stDomain/exportXls',
  loadTreeData = '/base.domain/stDomain/loadTreeRoot',
  getChildList = '/base.domain/stDomain/childList',
  getChildListBatch = '/base.domain/stDomain/getChildListBatch',
  changeParent = '/base.domain/stDomain/changeParent',
}

/**
 * 导出api
 * @param params
 */
export const getExportUrl = Api.exportXls;
/**
 * 导入api
 * @param params
 */
export const getImportUrl = Api.importExcel;
/**
 * 列表接口
 * @param params
 */
export const list = (params) =>
  defHttp.get({url: Api.list, params});
/**
 * 删除
 */
export const deleteStDomain = (params,handleSuccess) => {
  return defHttp.delete({url: Api.deleteStDomain, params}, {joinParamsToUrl: true}).then(() => {
    handleSuccess();
  });
}
/**
 * 批量删除
 * @param params
 */
export const batchDeleteStDomain = (params, handleSuccess) => {
  createConfirm({
    iconType: 'warning',
    title: '确认删除',
    content: '是否删除选中数据',
    okText: '确认',
    cancelText: '取消',
    onOk: () => {
      return defHttp.delete({url: Api.deleteStDomain, data: params}, {joinParamsToUrl: true}).then(() => {
        handleSuccess();
      });
    }
  });
}
/**
 * 保存或者更新
 * @param params
 */
export const saveOrUpdateDict = (params, isUpdate) => {
  let url = isUpdate ? Api.edit : Api.save;
  return defHttp.post({url: url, params});
}
export const changeParent = (params) => {
  return defHttp.post({url: Api.changeParent, params});
}
/**
 * 查询全部树形节点数据
 * @param params
 */
export const loadTreeData = (params) =>
  defHttp.get({url: Api.loadTreeData,params});
/**
 * 查询子节点数据
 * @param params
 */
export const getChildList = (params) =>
  defHttp.get({url: Api.getChildList, params});
/**
 * 批量查询子节点数据
 * @param params
 */
export const getChildListBatch = (params) =>
  defHttp.get({url: Api.getChildListBatch, params},{isTransformResponse:false});
